/* DateIterator.c generated by valac 0.56.14, the Vala compiler
 * generated from DateIterator.vala, do not modify */

/*
 * Copyright 2011-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "elementary-calendar.h"
#include <glib.h>
#include <glib-object.h>
#include <gee.h>

enum  {
	CALENDAR_UTIL_DATE_ITERATOR_0_PROPERTY,
	CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY,
	CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY,
	CALENDAR_UTIL_DATE_ITERATOR_VALID_PROPERTY,
	CALENDAR_UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY,
	CALENDAR_UTIL_DATE_ITERATOR_NUM_PROPERTIES
};
static GParamSpec* calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _CalendarUtilDateIteratorPrivate {
	GDateTime* _current;
	CalendarUtilDateRange* _range;
};

static gint CalendarUtilDateIterator_private_offset;
static gpointer calendar_util_date_iterator_parent_class = NULL;
static GeeTraversableIface * calendar_util_date_iterator_gee_traversable_parent_iface = NULL;
static GeeIteratorIface * calendar_util_date_iterator_gee_iterator_parent_iface = NULL;

static gboolean calendar_util_date_iterator_real_foreach (GeeTraversable* base,
                                                   GeeForallFunc f,
                                                   gpointer f_target);
static gboolean calendar_util_date_iterator_real_next (GeeIterator* base);
static gboolean calendar_util_date_iterator_real_has_next (GeeIterator* base);
static GDateTime* calendar_util_date_iterator_real_get (GeeIterator* base);
static void calendar_util_date_iterator_real_remove (GeeIterator* base);
static void calendar_util_date_iterator_finalize (GObject * obj);
static GType calendar_util_date_iterator_get_type_once (void);
static void _vala_calendar_util_date_iterator_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_calendar_util_date_iterator_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
calendar_util_date_iterator_get_instance_private (CalendarUtilDateIterator* self)
{
	return G_STRUCT_MEMBER_P (self, CalendarUtilDateIterator_private_offset);
}

CalendarUtilDateIterator*
calendar_util_date_iterator_construct (GType object_type,
                                       CalendarUtilDateRange* range)
{
	CalendarUtilDateIterator * self = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
#line 40 "../core/Services/Calendar/Util/DateIterator.vala"
	g_return_val_if_fail (range != NULL, NULL);
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = calendar_util_date_range_get_first_dt (range);
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp1_ = _tmp0_;
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp2_ = g_date_time_add_days (_tmp1_, -1);
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp3_ = _tmp2_;
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) g_object_new (object_type, "range", range, "current", _tmp3_, NULL);
#line 41 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_date_time_unref0 (_tmp3_);
#line 40 "../core/Services/Calendar/Util/DateIterator.vala"
	return self;
#line 108 "DateIterator.c"
}

CalendarUtilDateIterator*
calendar_util_date_iterator_new (CalendarUtilDateRange* range)
{
#line 40 "../core/Services/Calendar/Util/DateIterator.vala"
	return calendar_util_date_iterator_construct (CALENDAR_UTIL_TYPE_DATE_ITERATOR, range);
#line 116 "DateIterator.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 124 "DateIterator.c"
}

static gboolean
calendar_util_date_iterator_real_foreach (GeeTraversable* base,
                                          GeeForallFunc f,
                                          gpointer f_target)
{
	CalendarUtilDateIterator * self;
	GDateTime* element = NULL;
	CalendarUtilDateRange* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gboolean result;
#line 47 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_range;
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp1_ = calendar_util_date_range_get_first_dt (_tmp0_);
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp2_ = _tmp1_;
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp3_ = _g_date_time_ref0 (_tmp2_);
#line 48 "../core/Services/Calendar/Util/DateIterator.vala"
	element = _tmp3_;
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
	while (TRUE) {
#line 153 "DateIterator.c"
		GDateTime* _tmp4_;
		CalendarUtilDateRange* _tmp5_;
		GDateTime* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
		GDateTime* _tmp9_;
		GDateTime* _tmp10_;
		GDateTime* _tmp11_;
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp4_ = element;
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp5_ = self->priv->_range;
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp6_ = calendar_util_date_range_get_last_dt (_tmp5_);
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp7_ = _tmp6_;
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
		if (!(g_date_time_compare (_tmp4_, _tmp7_) < 0)) {
#line 50 "../core/Services/Calendar/Util/DateIterator.vala"
			break;
#line 174 "DateIterator.c"
		}
#line 51 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp8_ = element;
#line 51 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp9_ = _g_date_time_ref0 (_tmp8_);
#line 51 "../core/Services/Calendar/Util/DateIterator.vala"
		if (f (_tmp9_, f_target) == FALSE) {
#line 52 "../core/Services/Calendar/Util/DateIterator.vala"
			result = FALSE;
#line 52 "../core/Services/Calendar/Util/DateIterator.vala"
			_g_date_time_unref0 (element);
#line 52 "../core/Services/Calendar/Util/DateIterator.vala"
			return result;
#line 188 "DateIterator.c"
		}
#line 55 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp10_ = element;
#line 55 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp11_ = g_date_time_add_days (_tmp10_, 1);
#line 55 "../core/Services/Calendar/Util/DateIterator.vala"
		_g_date_time_unref0 (element);
#line 55 "../core/Services/Calendar/Util/DateIterator.vala"
		element = _tmp11_;
#line 198 "DateIterator.c"
	}
#line 58 "../core/Services/Calendar/Util/DateIterator.vala"
	result = TRUE;
#line 58 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_date_time_unref0 (element);
#line 58 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 206 "DateIterator.c"
}

static gboolean
calendar_util_date_iterator_real_next (GeeIterator* base)
{
	CalendarUtilDateIterator * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	gboolean result;
#line 61 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 62 "../core/Services/Calendar/Util/DateIterator.vala"
	if (!gee_iterator_has_next ((GeeIterator*) self)) {
#line 63 "../core/Services/Calendar/Util/DateIterator.vala"
		result = FALSE;
#line 63 "../core/Services/Calendar/Util/DateIterator.vala"
		return result;
#line 225 "DateIterator.c"
	}
#line 66 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 66 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp1_ = g_date_time_add_days (_tmp0_, 1);
#line 66 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp2_ = _tmp1_;
#line 66 "../core/Services/Calendar/Util/DateIterator.vala"
	calendar_util_date_iterator_set_current (self, _tmp2_);
#line 66 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_date_time_unref0 (_tmp2_);
#line 68 "../core/Services/Calendar/Util/DateIterator.vala"
	result = TRUE;
#line 68 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 241 "DateIterator.c"
}

/** Returns true if the next day after current would fall inside of range, 
     *  false otherwise.
     */
static gboolean
calendar_util_date_iterator_real_has_next (GeeIterator* base)
{
	CalendarUtilDateIterator * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	CalendarUtilDateRange* _tmp3_;
	GDateTime* _tmp4_;
	GDateTime* _tmp5_;
	gboolean _tmp6_;
	gboolean result;
#line 74 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp1_ = g_date_time_add_days (_tmp0_, 1);
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp2_ = _tmp1_;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp3_ = self->priv->_range;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp4_ = calendar_util_date_range_get_last_dt (_tmp3_);
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp5_ = _tmp4_;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp6_ = g_date_time_compare (_tmp2_, _tmp5_) < 0;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_date_time_unref0 (_tmp2_);
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	result = _tmp6_;
#line 75 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 281 "DateIterator.c"
}

static GDateTime*
calendar_util_date_iterator_real_get (GeeIterator* base)
{
	CalendarUtilDateIterator * self;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* result;
#line 78 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 79 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 79 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 79 "../core/Services/Calendar/Util/DateIterator.vala"
	result = _tmp1_;
#line 79 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 301 "DateIterator.c"
}

static void
calendar_util_date_iterator_real_remove (GeeIterator* base)
{
	CalendarUtilDateIterator * self;
#line 82 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 83 "../core/Services/Calendar/Util/DateIterator.vala"
	g_assert_not_reached ();
#line 312 "DateIterator.c"
}

GDateTime*
calendar_util_date_iterator_get_current (CalendarUtilDateIterator* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_current;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	result = _tmp0_;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 328 "DateIterator.c"
}

void
calendar_util_date_iterator_set_current (CalendarUtilDateIterator* self,
                                         GDateTime* value)
{
	GDateTime* old_value;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	g_return_if_fail (self != NULL);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	old_value = calendar_util_date_iterator_get_current (self);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	if (old_value != value) {
#line 342 "DateIterator.c"
		GDateTime* _tmp0_;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
		_g_date_time_unref0 (self->priv->_current);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
		self->priv->_current = _tmp0_;
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY]);
#line 352 "DateIterator.c"
	}
}

CalendarUtilDateRange*
calendar_util_date_iterator_get_range (CalendarUtilDateIterator* self)
{
	CalendarUtilDateRange* result;
	CalendarUtilDateRange* _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	_tmp0_ = self->priv->_range;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	result = _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 369 "DateIterator.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	return self ? g_object_ref (self) : NULL;
#line 377 "DateIterator.c"
}

static void
calendar_util_date_iterator_set_range (CalendarUtilDateIterator* self,
                                       CalendarUtilDateRange* value)
{
	CalendarUtilDateRange* old_value;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	g_return_if_fail (self != NULL);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	old_value = calendar_util_date_iterator_get_range (self);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	if (old_value != value) {
#line 391 "DateIterator.c"
		CalendarUtilDateRange* _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
		_g_object_unref0 (self->priv->_range);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
		self->priv->_range = _tmp0_;
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
		g_object_notify_by_pspec ((GObject *) self, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY]);
#line 401 "DateIterator.c"
	}
}

static gboolean
calendar_util_date_iterator_real_get_valid (GeeIterator* base)
{
	gboolean result;
	CalendarUtilDateIterator* self;
#line 28 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 29 "../core/Services/Calendar/Util/DateIterator.vala"
	result = TRUE;
#line 29 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 416 "DateIterator.c"
}

static gboolean
calendar_util_date_iterator_real_get_read_only (GeeIterator* base)
{
	gboolean result;
	CalendarUtilDateIterator* self;
#line 35 "../core/Services/Calendar/Util/DateIterator.vala"
	self = (CalendarUtilDateIterator*) base;
#line 36 "../core/Services/Calendar/Util/DateIterator.vala"
	result = FALSE;
#line 36 "../core/Services/Calendar/Util/DateIterator.vala"
	return result;
#line 430 "DateIterator.c"
}

static void
calendar_util_date_iterator_class_init (CalendarUtilDateIteratorClass * klass,
                                        gpointer klass_data)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	calendar_util_date_iterator_parent_class = g_type_class_peek_parent (klass);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	g_type_class_adjust_private_offset (klass, &CalendarUtilDateIterator_private_offset);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_calendar_util_date_iterator_get_property;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_calendar_util_date_iterator_set_property;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	G_OBJECT_CLASS (klass)->finalize = calendar_util_date_iterator_finalize;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY] = g_param_spec_boxed ("current", "current", "current", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY] = g_param_spec_object ("range", "range", "range", CALENDAR_UTIL_TYPE_DATE_RANGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_ITERATOR_VALID_PROPERTY, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_VALID_PROPERTY] = g_param_spec_boolean ("valid", "valid", "valid", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CALENDAR_UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY, calendar_util_date_iterator_properties[CALENDAR_UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY] = g_param_spec_boolean ("read-only", "read-only", "read-only", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 455 "DateIterator.c"
}

static GType
calendar_util_date_iterator_gee_traversable_get_g_type (CalendarUtilDateIterator* self)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	return (GType) G_TYPE_DATE_TIME;
#line 463 "DateIterator.c"
}

static GBoxedCopyFunc
calendar_util_date_iterator_gee_traversable_get_g_dup_func (CalendarUtilDateIterator* self)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	return (GBoxedCopyFunc) g_date_time_ref;
#line 471 "DateIterator.c"
}

static GDestroyNotify
calendar_util_date_iterator_gee_traversable_get_g_destroy_func (CalendarUtilDateIterator* self)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	return (GDestroyNotify) g_date_time_unref;
#line 479 "DateIterator.c"
}

static void
calendar_util_date_iterator_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                            gpointer iface_data)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	calendar_util_date_iterator_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) calendar_util_date_iterator_real_foreach;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) calendar_util_date_iterator_gee_traversable_get_g_type;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) calendar_util_date_iterator_gee_traversable_get_g_dup_func;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) calendar_util_date_iterator_gee_traversable_get_g_destroy_func;
#line 496 "DateIterator.c"
}

static void
calendar_util_date_iterator_gee_iterator_interface_init (GeeIteratorIface * iface,
                                                         gpointer iface_data)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	calendar_util_date_iterator_gee_iterator_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->next = (gboolean (*) (GeeIterator*)) calendar_util_date_iterator_real_next;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->has_next = (gboolean (*) (GeeIterator*)) calendar_util_date_iterator_real_has_next;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get = (gpointer (*) (GeeIterator*)) calendar_util_date_iterator_real_get;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->remove = (void (*) (GeeIterator*)) calendar_util_date_iterator_real_remove;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get_valid = calendar_util_date_iterator_real_get_valid;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	iface->get_read_only = calendar_util_date_iterator_real_get_read_only;
#line 517 "DateIterator.c"
}

static void
calendar_util_date_iterator_instance_init (CalendarUtilDateIterator * self,
                                           gpointer klass)
{
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	self->priv = calendar_util_date_iterator_get_instance_private (self);
#line 526 "DateIterator.c"
}

static void
calendar_util_date_iterator_finalize (GObject * obj)
{
	CalendarUtilDateIterator * self;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CALENDAR_UTIL_TYPE_DATE_ITERATOR, CalendarUtilDateIterator);
#line 23 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_date_time_unref0 (self->priv->_current);
#line 24 "../core/Services/Calendar/Util/DateIterator.vala"
	_g_object_unref0 (self->priv->_range);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	G_OBJECT_CLASS (calendar_util_date_iterator_parent_class)->finalize (obj);
#line 541 "DateIterator.c"
}

static GType
calendar_util_date_iterator_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CalendarUtilDateIteratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) calendar_util_date_iterator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CalendarUtilDateIterator), 0, (GInstanceInitFunc) calendar_util_date_iterator_instance_init, NULL };
	static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) calendar_util_date_iterator_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo gee_iterator_info = { (GInterfaceInitFunc) calendar_util_date_iterator_gee_iterator_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType calendar_util_date_iterator_type_id;
	calendar_util_date_iterator_type_id = g_type_register_static (G_TYPE_OBJECT, "CalendarUtilDateIterator", &g_define_type_info, 0);
	g_type_add_interface_static (calendar_util_date_iterator_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
	g_type_add_interface_static (calendar_util_date_iterator_type_id, GEE_TYPE_ITERATOR, &gee_iterator_info);
	CalendarUtilDateIterator_private_offset = g_type_add_instance_private (calendar_util_date_iterator_type_id, sizeof (CalendarUtilDateIteratorPrivate));
	return calendar_util_date_iterator_type_id;
}

GType
calendar_util_date_iterator_get_type (void)
{
	static volatile gsize calendar_util_date_iterator_type_id__once = 0;
	if (g_once_init_enter (&calendar_util_date_iterator_type_id__once)) {
		GType calendar_util_date_iterator_type_id;
		calendar_util_date_iterator_type_id = calendar_util_date_iterator_get_type_once ();
		g_once_init_leave (&calendar_util_date_iterator_type_id__once, calendar_util_date_iterator_type_id);
	}
	return calendar_util_date_iterator_type_id__once;
}

static void
_vala_calendar_util_date_iterator_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	CalendarUtilDateIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_UTIL_TYPE_DATE_ITERATOR, CalendarUtilDateIterator);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	switch (property_id) {
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		g_value_set_boxed (value, calendar_util_date_iterator_get_current (self));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		g_value_set_object (value, calendar_util_date_iterator_get_range (self));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_VALID_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		g_value_set_boolean (value, gee_iterator_get_valid ((GeeIterator*) self));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_READ_ONLY_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		g_value_set_boolean (value, gee_iterator_get_read_only ((GeeIterator*) self));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 604 "DateIterator.c"
		default:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 610 "DateIterator.c"
	}
}

static void
_vala_calendar_util_date_iterator_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	CalendarUtilDateIterator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, CALENDAR_UTIL_TYPE_DATE_ITERATOR, CalendarUtilDateIterator);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
	switch (property_id) {
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_CURRENT_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		calendar_util_date_iterator_set_current (self, g_value_get_boxed (value));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		case CALENDAR_UTIL_DATE_ITERATOR_RANGE_PROPERTY:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		calendar_util_date_iterator_set_range (self, g_value_get_object (value));
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 636 "DateIterator.c"
		default:
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../core/Services/Calendar/Util/DateIterator.vala"
		break;
#line 642 "DateIterator.c"
	}
}

