/* CalDAVBackend.c generated by valac 0.56.14, the Vala compiler
 * generated from CalDAVBackend.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2013 Maya Developers (https://launchpad.net/maya)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <tintou@mailoo.org>
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include "caldav.h"
#include <gmodule.h>
#include "elementary-calendar.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libedataserver/libedataserver.h>
#include <gee.h>
#include <gtk/gtk.h>

enum  {
	MAYA_CAL_DAV_BACKEND_0_PROPERTY,
	MAYA_CAL_DAV_BACKEND_NUM_PROPERTIES
};
static GParamSpec* maya_cal_dav_backend_properties[MAYA_CAL_DAV_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_uri_unref0(var) ((var == NULL) ? NULL : (var = (g_uri_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

MayaBackend* backend = NULL;
static gpointer maya_cal_dav_backend_parent_class = NULL;
static MayaBackendIface * maya_cal_dav_backend_maya_backend_parent_iface = NULL;

static gchar* maya_cal_dav_backend_real_get_name (MayaBackend* base);
static gchar* maya_cal_dav_backend_real_get_uid (MayaBackend* base);
static GeeCollection* maya_cal_dav_backend_real_get_new_calendar_widget (MayaBackend* base,
                                                                  ESource* to_edit);
static void maya_cal_dav_backend_real_add_new_calendar (MayaBackend* base,
                                                 const gchar* name,
                                                 const gchar* color,
                                                 gboolean set_default,
                                                 GeeCollection* widgets);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void maya_cal_dav_backend_real_modify_calendar (MayaBackend* base,
                                                const gchar* name,
                                                const gchar* color,
                                                gboolean set_default,
                                                GeeCollection* widgets,
                                                ESource* source);
static GType maya_cal_dav_backend_get_type_once (void);

MayaBackend*
get_backend (GModule* module)
{
	MayaCalDavBackend* b = NULL;
	MayaCalDavBackend* _tmp0_;
	MayaBackend* result;
#line 23 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 24 "../plugins/CalDAV/CalDAVBackend.vala"
	g_debug ("CalDAVBackend.vala:24: Activating CalDAV Backend");
#line 25 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp0_ = maya_cal_dav_backend_new ();
#line 25 "../plugins/CalDAV/CalDAVBackend.vala"
	b = _tmp0_;
#line 26 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_ref ((GObject*) b);
#line 27 "../plugins/CalDAV/CalDAVBackend.vala"
	result = (MayaBackend*) b;
#line 27 "../plugins/CalDAV/CalDAVBackend.vala"
	return result;
#line 98 "CalDAVBackend.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../plugins/CalDAV/CalDAVBackend.vala"
	return self ? g_object_ref (self) : NULL;
#line 106 "CalDAVBackend.c"
}

MayaCalDavBackend*
maya_cal_dav_backend_construct (GType object_type)
{
	MayaCalDavBackend * self = NULL;
	MayaBackend* _tmp0_;
#line 34 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) g_object_new (object_type, NULL);
#line 35 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp0_ = _g_object_ref0 ((MayaBackend*) self);
#line 35 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (backend);
#line 35 "../plugins/CalDAV/CalDAVBackend.vala"
	backend = _tmp0_;
#line 34 "../plugins/CalDAV/CalDAVBackend.vala"
	return self;
#line 124 "CalDAVBackend.c"
}

MayaCalDavBackend*
maya_cal_dav_backend_new (void)
{
#line 34 "../plugins/CalDAV/CalDAVBackend.vala"
	return maya_cal_dav_backend_construct (MAYA_TYPE_CAL_DAV_BACKEND);
#line 132 "CalDAVBackend.c"
}

static gchar*
maya_cal_dav_backend_real_get_name (MayaBackend* base)
{
	MayaCalDavBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 38 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) base;
#line 39 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp0_ = g_strdup (_ ("CalDAV"));
#line 39 "../plugins/CalDAV/CalDAVBackend.vala"
	result = _tmp0_;
#line 39 "../plugins/CalDAV/CalDAVBackend.vala"
	return result;
#line 149 "CalDAVBackend.c"
}

static gchar*
maya_cal_dav_backend_real_get_uid (MayaBackend* base)
{
	MayaCalDavBackend * self;
	gchar* _tmp0_;
	gchar* result;
#line 42 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) base;
#line 43 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp0_ = g_strdup ("caldav-stub");
#line 43 "../plugins/CalDAV/CalDAVBackend.vala"
	result = _tmp0_;
#line 43 "../plugins/CalDAV/CalDAVBackend.vala"
	return result;
#line 166 "CalDAVBackend.c"
}

static GeeCollection*
maya_cal_dav_backend_real_get_new_calendar_widget (MayaBackend* base,
                                                   ESource* to_edit)
{
	MayaCalDavBackend * self;
	GeeLinkedList* collection = NULL;
	GeeLinkedList* _tmp0_;
	gboolean keep_copy = FALSE;
	GeeLinkedList* _tmp6_;
	MayaPlacementWidget* _tmp7_;
	MayaPlacementWidget* _tmp8_;
	MayaPlacementWidget* url_label = NULL;
	MayaPlacementWidget* _tmp9_;
	MayaPlacementWidget* _tmp10_;
	GtkLabel* _tmp11_;
	MayaPlacementWidget* _tmp12_;
	GtkWidget* _tmp13_;
	MayaPlacementWidget* _tmp14_;
	GtkWidget* _tmp15_;
	MayaPlacementWidget* _tmp16_;
	MayaPlacementWidget* _tmp17_;
	MayaPlacementWidget* _tmp18_;
	gchar* _tmp19_;
	GeeLinkedList* _tmp20_;
	MayaPlacementWidget* _tmp21_;
	MayaPlacementWidget* url_entry = NULL;
	MayaPlacementWidget* _tmp22_;
	MayaPlacementWidget* _tmp23_;
	GtkEntry* _tmp24_;
	MayaPlacementWidget* _tmp25_;
	GtkWidget* _tmp26_;
	MayaPlacementWidget* _tmp27_;
	MayaPlacementWidget* _tmp28_;
	MayaPlacementWidget* _tmp29_;
	gchar* _tmp30_;
	MayaPlacementWidget* _tmp31_;
	GeeLinkedList* _tmp32_;
	MayaPlacementWidget* _tmp33_;
	MayaPlacementWidget* secure_checkbutton = NULL;
	MayaPlacementWidget* _tmp60_;
	MayaPlacementWidget* _tmp61_;
	GtkCheckButton* _tmp62_;
	MayaPlacementWidget* _tmp63_;
	MayaPlacementWidget* _tmp64_;
	MayaPlacementWidget* _tmp65_;
	gchar* _tmp66_;
	GeeLinkedList* _tmp67_;
	MayaPlacementWidget* _tmp68_;
	gchar* user = NULL;
	gchar* _tmp76_;
	GeeLinkedList* _tmp86_;
	const gchar* _tmp87_;
	GeeLinkedList* _tmp88_;
	GeeLinkedList* _tmp89_;
	gchar* email = NULL;
	gchar* _tmp90_;
	GeeLinkedList* _tmp100_;
	const gchar* _tmp101_;
	GeeLinkedList* _tmp102_;
	GeeLinkedList* _tmp103_;
	MayaPlacementWidget* server_checkbutton = NULL;
	MayaPlacementWidget* _tmp104_;
	MayaPlacementWidget* _tmp105_;
	GtkCheckButton* _tmp106_;
	MayaPlacementWidget* _tmp107_;
	MayaPlacementWidget* _tmp108_;
	MayaPlacementWidget* _tmp109_;
	gchar* _tmp110_;
	GeeLinkedList* _tmp118_;
	MayaPlacementWidget* _tmp119_;
	GeeCollection* result;
#line 46 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) base;
#line 47 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp0_ = gee_linked_list_new (MAYA_TYPE_PLACEMENT_WIDGET, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 47 "../plugins/CalDAV/CalDAVBackend.vala"
	collection = _tmp0_;
#line 49 "../plugins/CalDAV/CalDAVBackend.vala"
	keep_copy = FALSE;
#line 50 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 250 "CalDAVBackend.c"
		ESourceOffline* source_offline = NULL;
		ESourceExtension* _tmp1_;
		ESourceOffline* _tmp2_;
		ESourceOffline* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 51 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp1_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_OFFLINE);
#line 51 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, e_source_offline_get_type (), ESourceOffline));
#line 51 "../plugins/CalDAV/CalDAVBackend.vala"
		source_offline = _tmp2_;
#line 52 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp3_ = source_offline;
#line 52 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp4_ = e_source_offline_get_stay_synchronized (_tmp3_);
#line 52 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp5_ = _tmp4_;
#line 52 "../plugins/CalDAV/CalDAVBackend.vala"
		keep_copy = _tmp5_;
#line 50 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (source_offline);
#line 273 "CalDAVBackend.c"
	}
#line 55 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp6_ = collection;
#line 55 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp7_ = maya_default_placement_widgets_get_keep_copy (0, keep_copy);
#line 55 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp8_ = _tmp7_;
#line 55 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp8_);
#line 55 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp8_);
#line 57 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp9_ = maya_placement_widget_new ();
#line 57 "../plugins/CalDAV/CalDAVBackend.vala"
	url_label = _tmp9_;
#line 58 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp10_ = url_label;
#line 58 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new (_ ("URL:"));
#line 58 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_ref_sink (_tmp11_);
#line 58 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp10_->widget);
#line 58 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp10_->widget = (GtkWidget*) _tmp11_;
#line 59 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp12_ = url_label;
#line 59 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp13_ = _tmp12_->widget;
#line 59 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_set ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_label_get_type (), GtkLabel), "expand", TRUE, NULL);
#line 60 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp14_ = url_label;
#line 60 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp15_ = _tmp14_->widget;
#line 60 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_misc_get_type (), GtkMisc), "xalign", 1.0f, NULL);
#line 61 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp16_ = url_label;
#line 61 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp16_->row = 1;
#line 62 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp17_ = url_label;
#line 62 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp17_->column = 0;
#line 63 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp18_ = url_label;
#line 63 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp19_ = g_strdup ("url_label");
#line 63 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (_tmp18_->ref_name);
#line 63 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp18_->ref_name = _tmp19_;
#line 64 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp20_ = collection;
#line 64 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp21_ = url_label;
#line 64 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 66 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp22_ = maya_placement_widget_new ();
#line 66 "../plugins/CalDAV/CalDAVBackend.vala"
	url_entry = _tmp22_;
#line 67 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp23_ = url_entry;
#line 67 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp24_ = (GtkEntry*) gtk_entry_new ();
#line 67 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_ref_sink (_tmp24_);
#line 67 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp23_->widget);
#line 67 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp23_->widget = (GtkWidget*) _tmp24_;
#line 68 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp25_ = url_entry;
#line 68 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp26_ = _tmp25_->widget;
#line 68 "../plugins/CalDAV/CalDAVBackend.vala"
	gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_entry_get_type (), GtkEntry), "http://");
#line 69 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp27_ = url_entry;
#line 69 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp27_->row = 1;
#line 70 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp28_ = url_entry;
#line 70 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp28_->column = 1;
#line 71 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp29_ = url_entry;
#line 71 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp30_ = g_strdup ("url_entry");
#line 71 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (_tmp29_->ref_name);
#line 71 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp29_->ref_name = _tmp30_;
#line 72 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp31_ = url_entry;
#line 72 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp31_->needed = TRUE;
#line 73 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp32_ = collection;
#line 73 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp33_ = url_entry;
#line 73 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
#line 74 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 381 "CalDAVBackend.c"
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp34_;
		ESourceWebdav* _tmp35_;
		GUri* uri = NULL;
		ESourceWebdav* _tmp36_;
		GUri* _tmp37_;
		GUri* _tmp38_;
#line 75 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp34_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 75 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, e_source_webdav_get_type (), ESourceWebdav));
#line 75 "../plugins/CalDAV/CalDAVBackend.vala"
		webdav = _tmp35_;
#line 77 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp36_ = webdav;
#line 77 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp37_ = e_source_webdav_dup_uri (_tmp36_);
#line 77 "../plugins/CalDAV/CalDAVBackend.vala"
		uri = _tmp37_;
#line 81 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp38_ = uri;
#line 81 "../plugins/CalDAV/CalDAVBackend.vala"
		if (g_uri_get_port (_tmp38_) != 80) {
#line 405 "CalDAVBackend.c"
			MayaPlacementWidget* _tmp39_;
			GtkWidget* _tmp40_;
			GUri* _tmp41_;
			const gchar* _tmp42_;
			GUri* _tmp43_;
			const gchar* _tmp44_;
			GUri* _tmp45_;
			GUri* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp39_ = url_entry;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp40_ = _tmp39_->widget;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp41_ = uri;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp42_ = g_uri_get_scheme (_tmp41_);
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp43_ = uri;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp44_ = g_uri_get_host (_tmp43_);
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp45_ = uri;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp46_ = uri;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp47_ = g_uri_get_path (_tmp46_);
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp48_ = g_strdup_printf ("%s://%s:%u%s", _tmp42_, _tmp44_, (guint) g_uri_get_port (_tmp45_), _tmp47_);
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp49_ = _tmp48_;
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_entry_get_type (), GtkEntry), _tmp49_);
#line 82 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_free0 (_tmp49_);
#line 443 "CalDAVBackend.c"
		} else {
			MayaPlacementWidget* _tmp50_;
			GtkWidget* _tmp51_;
			GUri* _tmp52_;
			const gchar* _tmp53_;
			GUri* _tmp54_;
			const gchar* _tmp55_;
			GUri* _tmp56_;
			const gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp50_ = url_entry;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp51_ = _tmp50_->widget;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp52_ = uri;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp53_ = g_uri_get_scheme (_tmp52_);
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp54_ = uri;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp55_ = g_uri_get_host (_tmp54_);
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp56_ = uri;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp57_ = g_uri_get_path (_tmp56_);
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp58_ = g_strdup_printf ("%s://%s%s", _tmp53_, _tmp55_, _tmp57_);
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp59_ = _tmp58_;
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, gtk_entry_get_type (), GtkEntry), _tmp59_);
#line 84 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_free0 (_tmp59_);
#line 479 "CalDAVBackend.c"
		}
#line 74 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_uri_unref0 (uri);
#line 74 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (webdav);
#line 485 "CalDAVBackend.c"
	}
#line 98 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp60_ = maya_placement_widget_new ();
#line 98 "../plugins/CalDAV/CalDAVBackend.vala"
	secure_checkbutton = _tmp60_;
#line 99 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp61_ = secure_checkbutton;
#line 99 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp62_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Use a secure connection"));
#line 99 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_ref_sink (_tmp62_);
#line 99 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp61_->widget);
#line 99 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp61_->widget = (GtkWidget*) _tmp62_;
#line 100 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp63_ = secure_checkbutton;
#line 100 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp63_->row = 3;
#line 101 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp64_ = secure_checkbutton;
#line 101 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp64_->column = 1;
#line 102 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp65_ = secure_checkbutton;
#line 102 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp66_ = g_strdup ("secure_checkbutton");
#line 102 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (_tmp65_->ref_name);
#line 102 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp65_->ref_name = _tmp66_;
#line 103 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp67_ = collection;
#line 103 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp68_ = secure_checkbutton;
#line 103 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp67_, _tmp68_);
#line 104 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 525 "CalDAVBackend.c"
		ESourceSecurity* security = NULL;
		ESourceExtension* _tmp69_;
		ESourceSecurity* _tmp70_;
		MayaPlacementWidget* _tmp71_;
		GtkWidget* _tmp72_;
		ESourceSecurity* _tmp73_;
		gboolean _tmp74_;
		gboolean _tmp75_;
#line 105 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp69_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_SECURITY);
#line 105 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp70_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, e_source_security_get_type (), ESourceSecurity));
#line 105 "../plugins/CalDAV/CalDAVBackend.vala"
		security = _tmp70_;
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp71_ = secure_checkbutton;
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp72_ = _tmp71_->widget;
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp73_ = security;
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp74_ = e_source_security_get_secure (_tmp73_);
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp75_ = _tmp74_;
#line 106 "../plugins/CalDAV/CalDAVBackend.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp72_, gtk_check_button_get_type (), GtkCheckButton), _tmp75_);
#line 104 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (security);
#line 554 "CalDAVBackend.c"
	}
#line 109 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp76_ = g_strdup ("");
#line 109 "../plugins/CalDAV/CalDAVBackend.vala"
	user = _tmp76_;
#line 110 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 562 "CalDAVBackend.c"
		ESourceAuthentication* auth = NULL;
		ESourceExtension* _tmp77_;
		ESourceAuthentication* _tmp78_;
		ESourceAuthentication* _tmp79_;
		const gchar* _tmp80_;
		const gchar* _tmp81_;
#line 111 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp77_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 111 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp78_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, e_source_authentication_get_type (), ESourceAuthentication));
#line 111 "../plugins/CalDAV/CalDAVBackend.vala"
		auth = _tmp78_;
#line 112 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp79_ = auth;
#line 112 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp80_ = e_source_authentication_get_user (_tmp79_);
#line 112 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp81_ = _tmp80_;
#line 112 "../plugins/CalDAV/CalDAVBackend.vala"
		if (_tmp81_ != NULL) {
#line 583 "CalDAVBackend.c"
			ESourceAuthentication* _tmp82_;
			const gchar* _tmp83_;
			const gchar* _tmp84_;
			gchar* _tmp85_;
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp82_ = auth;
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp83_ = e_source_authentication_get_user (_tmp82_);
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp84_ = _tmp83_;
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp85_ = g_strdup (_tmp84_);
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_free0 (user);
#line 113 "../plugins/CalDAV/CalDAVBackend.vala"
			user = _tmp85_;
#line 600 "CalDAVBackend.c"
		}
#line 110 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (auth);
#line 604 "CalDAVBackend.c"
	}
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp86_ = collection;
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp87_ = user;
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp88_ = maya_default_placement_widgets_get_user (4, TRUE, _tmp87_, NULL);
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp89_ = _tmp88_;
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_collection_add_all ((GeeCollection*) _tmp86_, (GeeCollection*) _tmp89_);
#line 115 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp89_);
#line 117 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp90_ = g_strdup ("");
#line 117 "../plugins/CalDAV/CalDAVBackend.vala"
	email = _tmp90_;
#line 118 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 624 "CalDAVBackend.c"
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp91_;
		ESourceWebdav* _tmp92_;
		ESourceWebdav* _tmp93_;
		const gchar* _tmp94_;
		const gchar* _tmp95_;
#line 119 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp91_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 119 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp92_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, e_source_webdav_get_type (), ESourceWebdav));
#line 119 "../plugins/CalDAV/CalDAVBackend.vala"
		webdav = _tmp92_;
#line 120 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp93_ = webdav;
#line 120 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp94_ = e_source_webdav_get_email_address (_tmp93_);
#line 120 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp95_ = _tmp94_;
#line 120 "../plugins/CalDAV/CalDAVBackend.vala"
		if (_tmp95_ != NULL) {
#line 645 "CalDAVBackend.c"
			ESourceWebdav* _tmp96_;
			const gchar* _tmp97_;
			const gchar* _tmp98_;
			gchar* _tmp99_;
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp96_ = webdav;
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp97_ = e_source_webdav_get_email_address (_tmp96_);
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp98_ = _tmp97_;
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp99_ = g_strdup (_tmp98_);
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_free0 (email);
#line 121 "../plugins/CalDAV/CalDAVBackend.vala"
			email = _tmp99_;
#line 662 "CalDAVBackend.c"
		}
#line 118 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (webdav);
#line 666 "CalDAVBackend.c"
	}
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp100_ = collection;
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp101_ = email;
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp102_ = maya_default_placement_widgets_get_email (5, FALSE, _tmp101_, NULL);
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp103_ = _tmp102_;
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_collection_add_all ((GeeCollection*) _tmp100_, (GeeCollection*) _tmp103_);
#line 124 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp103_);
#line 126 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp104_ = maya_placement_widget_new ();
#line 126 "../plugins/CalDAV/CalDAVBackend.vala"
	server_checkbutton = _tmp104_;
#line 127 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp105_ = server_checkbutton;
#line 127 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp106_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Server handles meeting invitations"));
#line 127 "../plugins/CalDAV/CalDAVBackend.vala"
	g_object_ref_sink (_tmp106_);
#line 127 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (_tmp105_->widget);
#line 127 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp105_->widget = (GtkWidget*) _tmp106_;
#line 128 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp107_ = server_checkbutton;
#line 128 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp107_->row = 6;
#line 129 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp108_ = server_checkbutton;
#line 129 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp108_->column = 1;
#line 130 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp109_ = server_checkbutton;
#line 130 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp110_ = g_strdup ("server_checkbutton");
#line 130 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (_tmp109_->ref_name);
#line 130 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp109_->ref_name = _tmp110_;
#line 131 "../plugins/CalDAV/CalDAVBackend.vala"
	if (to_edit != NULL) {
#line 712 "CalDAVBackend.c"
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp111_;
		ESourceWebdav* _tmp112_;
		MayaPlacementWidget* _tmp113_;
		GtkWidget* _tmp114_;
		ESourceWebdav* _tmp115_;
		gboolean _tmp116_;
		gboolean _tmp117_;
#line 132 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp111_ = e_source_get_extension (to_edit, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 132 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp112_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, e_source_webdav_get_type (), ESourceWebdav));
#line 132 "../plugins/CalDAV/CalDAVBackend.vala"
		webdav = _tmp112_;
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp113_ = server_checkbutton;
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp114_ = _tmp113_->widget;
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp115_ = webdav;
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp116_ = e_source_webdav_get_calendar_auto_schedule (_tmp115_);
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp117_ = _tmp116_;
#line 133 "../plugins/CalDAV/CalDAVBackend.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp114_, gtk_check_button_get_type (), GtkCheckButton), _tmp117_);
#line 131 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (webdav);
#line 741 "CalDAVBackend.c"
	}
#line 136 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp118_ = collection;
#line 136 "../plugins/CalDAV/CalDAVBackend.vala"
	_tmp119_ = server_checkbutton;
#line 136 "../plugins/CalDAV/CalDAVBackend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp118_, _tmp119_);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	result = (GeeCollection*) collection;
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (server_checkbutton);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (email);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_free0 (user);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (secure_checkbutton);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (url_entry);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	_g_object_unref0 (url_label);
#line 137 "../plugins/CalDAV/CalDAVBackend.vala"
	return result;
#line 765 "CalDAVBackend.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 773 "CalDAVBackend.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 781 "CalDAVBackend.c"
}

static void
maya_cal_dav_backend_real_add_new_calendar (MayaBackend* base,
                                            const gchar* name,
                                            const gchar* color,
                                            gboolean set_default,
                                            GeeCollection* widgets)
{
	MayaCalDavBackend * self;
	GError* _inner_error0_ = NULL;
#line 140 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) base;
#line 140 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (name != NULL);
#line 140 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (color != NULL);
#line 140 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 801 "CalDAVBackend.c"
	{
		ESource* new_source = NULL;
		ESource* _tmp0_;
		ESource* _tmp1_;
		ESource* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		ESourceCalendar* cal = NULL;
		ESource* _tmp5_;
		ESourceExtension* _tmp6_;
		ESourceCalendar* _tmp7_;
		ESourceCalendar* _tmp8_;
		ESourceCalendar* _tmp9_;
		ESourceWebdav* webdav = NULL;
		ESource* _tmp10_;
		ESourceExtension* _tmp11_;
		ESourceWebdav* _tmp12_;
		ESourceAuthentication* auth = NULL;
		ESource* _tmp13_;
		ESourceExtension* _tmp14_;
		ESourceAuthentication* _tmp15_;
		ESourceOffline* offline = NULL;
		ESource* _tmp16_;
		ESourceExtension* _tmp17_;
		ESourceOffline* _tmp18_;
		CalendarEventStore* calmodel = NULL;
		CalendarEventStore* _tmp55_;
		ESourceRegistry* registry = NULL;
		CalendarEventStore* _tmp56_;
		ESourceRegistry* _tmp57_;
		ESourceRegistry* _tmp58_;
		ESourceRegistry* _tmp59_;
		GList* list = NULL;
		ESource* _tmp60_;
		ESource* _tmp61_;
		ESourceRegistry* _tmp62_;
		GList* _tmp63_;
		CalendarEventStore* _tmp64_;
		ESource* _tmp65_;
#line 142 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp0_ = e_source_new (NULL, NULL, &_inner_error0_);
#line 142 "../plugins/CalDAV/CalDAVBackend.vala"
		new_source = _tmp0_;
#line 142 "../plugins/CalDAV/CalDAVBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 847 "CalDAVBackend.c"
			goto __catch0_g_error;
		}
#line 143 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp1_ = new_source;
#line 143 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_set_display_name (_tmp1_, name);
#line 144 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp2_ = new_source;
#line 144 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp3_ = maya_backend_get_uid ((MayaBackend*) self);
#line 144 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp4_ = _tmp3_;
#line 144 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_set_parent (_tmp2_, _tmp4_);
#line 144 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_free0 (_tmp4_);
#line 145 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp5_ = new_source;
#line 145 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp6_ = e_source_get_extension (_tmp5_, E_SOURCE_EXTENSION_CALENDAR);
#line 145 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, e_source_calendar_get_type (), ESourceCalendar));
#line 145 "../plugins/CalDAV/CalDAVBackend.vala"
		cal = _tmp7_;
#line 146 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp8_ = cal;
#line 146 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp8_, color);
#line 147 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp9_ = cal;
#line 147 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_backend_set_backend_name ((ESourceBackend*) _tmp9_, "caldav");
#line 148 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp10_ = new_source;
#line 148 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp11_ = e_source_get_extension (_tmp10_, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 148 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, e_source_webdav_get_type (), ESourceWebdav));
#line 148 "../plugins/CalDAV/CalDAVBackend.vala"
		webdav = _tmp12_;
#line 149 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp13_ = new_source;
#line 149 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp14_ = e_source_get_extension (_tmp13_, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 149 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, e_source_authentication_get_type (), ESourceAuthentication));
#line 149 "../plugins/CalDAV/CalDAVBackend.vala"
		auth = _tmp15_;
#line 150 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp16_ = new_source;
#line 150 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp17_ = e_source_get_extension (_tmp16_, E_SOURCE_EXTENSION_OFFLINE);
#line 150 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp18_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, e_source_offline_get_type (), ESourceOffline));
#line 150 "../plugins/CalDAV/CalDAVBackend.vala"
		offline = _tmp18_;
#line 904 "CalDAVBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp19_;
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp19_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
			_widget_it = _tmp19_;
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
			while (TRUE) {
#line 914 "CalDAVBackend.c"
				GeeIterator* _tmp20_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp21_;
				gpointer _tmp22_;
				MayaPlacementWidget* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				GQuark _tmp27_ = 0U;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp26_label0 = 0;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp26_label1 = 0;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp26_label2 = 0;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp26_label3 = 0;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp26_label4 = 0;
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp20_ = _widget_it;
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				if (!gee_iterator_next (_tmp20_)) {
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
					break;
#line 939 "CalDAVBackend.c"
				}
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp21_ = _widget_it;
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp22_ = gee_iterator_get (_tmp21_);
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				widget = (MayaPlacementWidget*) _tmp22_;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp23_ = widget;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp24_ = _tmp23_->ref_name;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp25_ = _tmp24_;
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp27_ = (NULL == _tmp25_) ? 0 : g_quark_from_string (_tmp25_);
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
				if (_tmp27_ == ((0 != _tmp26_label0) ? _tmp26_label0 : (_tmp26_label0 = g_quark_from_static_string ("url_entry")))) {
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 959 "CalDAVBackend.c"
						default:
						{
							GUri* _tmp28_ = NULL;
							MayaPlacementWidget* _tmp29_;
							GtkWidget* _tmp30_;
							const gchar* _tmp31_;
							const gchar* _tmp32_;
							GUri* _tmp33_;
							ESourceWebdav* _tmp34_;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp29_ = widget;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp30_ = _tmp29_->widget;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp31_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_entry_get_type (), GtkEntry));
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp32_ = _tmp31_;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp33_ = g_uri_parse (_tmp32_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp28_ = _tmp33_;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (widget);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (_widget_it);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (offline);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (auth);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (webdav);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (cal);
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (new_source);
#line 997 "CalDAVBackend.c"
								goto __catch0_g_error;
							}
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp34_ = webdav;
#line 155 "../plugins/CalDAV/CalDAVBackend.vala"
							g_object_set (_tmp34_, "uri", _tmp28_, NULL);
#line 159 "../plugins/CalDAV/CalDAVBackend.vala"
							_g_uri_unref0 (_tmp28_);
#line 159 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1008 "CalDAVBackend.c"
						}
					}
				} else if (_tmp27_ == ((0 != _tmp26_label1) ? _tmp26_label1 : (_tmp26_label1 = g_quark_from_static_string ("user_entry")))) {
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1014 "CalDAVBackend.c"
						default:
						{
							ESourceAuthentication* _tmp35_;
							MayaPlacementWidget* _tmp36_;
							GtkWidget* _tmp37_;
							const gchar* _tmp38_;
							const gchar* _tmp39_;
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp35_ = auth;
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp36_ = widget;
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp37_ = _tmp36_->widget;
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp38_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_entry_get_type (), GtkEntry));
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp39_ = _tmp38_;
#line 161 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_authentication_set_user (_tmp35_, _tmp39_);
#line 162 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1036 "CalDAVBackend.c"
						}
					}
				} else if (_tmp27_ == ((0 != _tmp26_label2) ? _tmp26_label2 : (_tmp26_label2 = g_quark_from_static_string ("email_entry")))) {
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1042 "CalDAVBackend.c"
						default:
						{
							ESourceWebdav* _tmp40_;
							MayaPlacementWidget* _tmp41_;
							GtkWidget* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp40_ = webdav;
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp41_ = widget;
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp42_ = _tmp41_->widget;
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp43_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_entry_get_type (), GtkEntry));
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp44_ = _tmp43_;
#line 164 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_webdav_set_email_address (_tmp40_, _tmp44_);
#line 165 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1064 "CalDAVBackend.c"
						}
					}
				} else if (_tmp27_ == ((0 != _tmp26_label3) ? _tmp26_label3 : (_tmp26_label3 = g_quark_from_static_string ("server_checkbutton")))) {
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1070 "CalDAVBackend.c"
						default:
						{
							ESourceWebdav* _tmp45_;
							MayaPlacementWidget* _tmp46_;
							GtkWidget* _tmp47_;
							gboolean _tmp48_;
							gboolean _tmp49_;
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp45_ = webdav;
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp46_ = widget;
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp47_ = _tmp46_->widget;
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp48_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, gtk_check_button_get_type (), GtkCheckButton));
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp49_ = _tmp48_;
#line 167 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_webdav_set_calendar_auto_schedule (_tmp45_, _tmp49_);
#line 168 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1092 "CalDAVBackend.c"
						}
					}
				} else if (_tmp27_ == ((0 != _tmp26_label4) ? _tmp26_label4 : (_tmp26_label4 = g_quark_from_static_string ("keep_copy")))) {
#line 152 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1098 "CalDAVBackend.c"
						default:
						{
							ESourceOffline* _tmp50_;
							MayaPlacementWidget* _tmp51_;
							GtkWidget* _tmp52_;
							gboolean _tmp53_;
							gboolean _tmp54_;
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp50_ = offline;
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp51_ = widget;
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp52_ = _tmp51_->widget;
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp53_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_check_button_get_type (), GtkCheckButton));
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp54_ = _tmp53_;
#line 170 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp50_, _tmp54_);
#line 171 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1120 "CalDAVBackend.c"
						}
					}
				}
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (widget);
#line 1126 "CalDAVBackend.c"
			}
#line 151 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (_widget_it);
#line 1130 "CalDAVBackend.c"
		}
#line 175 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp55_ = calendar_event_store_get_default ();
#line 175 "../plugins/CalDAV/CalDAVBackend.vala"
		calmodel = _tmp55_;
#line 176 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp56_ = calmodel;
#line 176 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp57_ = calendar_event_store_get_registry (_tmp56_);
#line 176 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp58_ = _tmp57_;
#line 176 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp59_ = _g_object_ref0 (_tmp58_);
#line 176 "../plugins/CalDAV/CalDAVBackend.vala"
		registry = _tmp59_;
#line 177 "../plugins/CalDAV/CalDAVBackend.vala"
		list = NULL;
#line 178 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp60_ = new_source;
#line 178 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp61_ = _g_object_ref0 (_tmp60_);
#line 178 "../plugins/CalDAV/CalDAVBackend.vala"
		list = g_list_append (list, _tmp61_);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp62_ = registry;
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp63_ = list;
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_registry_create_sources_sync (_tmp62_, _tmp63_, NULL, &_inner_error0_);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (registry);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (calmodel);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (offline);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (auth);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (webdav);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (cal);
#line 179 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (new_source);
#line 1178 "CalDAVBackend.c"
			goto __catch0_g_error;
		}
#line 180 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp64_ = calmodel;
#line 180 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp65_ = new_source;
#line 180 "../plugins/CalDAV/CalDAVBackend.vala"
		calendar_event_store_add_source (_tmp64_, _tmp65_);
#line 181 "../plugins/CalDAV/CalDAVBackend.vala"
		if (set_default) {
#line 1189 "CalDAVBackend.c"
			ESourceRegistry* _tmp66_;
			ESource* _tmp67_;
#line 182 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp66_ = registry;
#line 182 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp67_ = new_source;
#line 182 "../plugins/CalDAV/CalDAVBackend.vala"
			g_object_set (_tmp66_, "default-calendar", _tmp67_, NULL);
#line 1198 "CalDAVBackend.c"
		}
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		(list == NULL) ? NULL : (list = (_g_list_free__g_object_unref0_ (list), NULL));
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (registry);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (calmodel);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (offline);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (auth);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (webdav);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (cal);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (new_source);
#line 1216 "CalDAVBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp68_;
		const gchar* _tmp69_;
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_error_ = _inner_error0_;
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_inner_error0_ = NULL;
#line 186 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp68_ = _error_;
#line 186 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp69_ = _tmp68_->message;
#line 186 "../plugins/CalDAV/CalDAVBackend.vala"
		g_critical ("CalDAVBackend.vala:186: %s", _tmp69_);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_error_free0 (_error_);
#line 1236 "CalDAVBackend.c"
	}
	__finally0:
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		g_clear_error (&_inner_error0_);
#line 141 "../plugins/CalDAV/CalDAVBackend.vala"
		return;
#line 1247 "CalDAVBackend.c"
	}
}

static void
maya_cal_dav_backend_real_modify_calendar (MayaBackend* base,
                                           const gchar* name,
                                           const gchar* color,
                                           gboolean set_default,
                                           GeeCollection* widgets,
                                           ESource* source)
{
	MayaCalDavBackend * self;
	GError* _inner_error0_ = NULL;
#line 190 "../plugins/CalDAV/CalDAVBackend.vala"
	self = (MayaCalDavBackend*) base;
#line 190 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (name != NULL);
#line 190 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (color != NULL);
#line 190 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (widgets != NULL);
#line 190 "../plugins/CalDAV/CalDAVBackend.vala"
	g_return_if_fail (source != NULL);
#line 1271 "CalDAVBackend.c"
	{
		ESourceCalendar* cal = NULL;
		ESourceExtension* _tmp0_;
		ESourceCalendar* _tmp1_;
		ESourceCalendar* _tmp2_;
		ESourceWebdav* webdav = NULL;
		ESourceExtension* _tmp3_;
		ESourceWebdav* _tmp4_;
		ESourceAuthentication* auth = NULL;
		ESourceExtension* _tmp5_;
		ESourceAuthentication* _tmp6_;
		ESourceOffline* offline = NULL;
		ESourceExtension* _tmp7_;
		ESourceOffline* _tmp8_;
#line 192 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_set_display_name (source, name);
#line 193 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp0_ = e_source_get_extension (source, E_SOURCE_EXTENSION_CALENDAR);
#line 193 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_calendar_get_type (), ESourceCalendar));
#line 193 "../plugins/CalDAV/CalDAVBackend.vala"
		cal = _tmp1_;
#line 194 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp2_ = cal;
#line 194 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_selectable_set_color ((ESourceSelectable*) _tmp2_, color);
#line 195 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp3_ = e_source_get_extension (source, E_SOURCE_EXTENSION_WEBDAV_BACKEND);
#line 195 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, e_source_webdav_get_type (), ESourceWebdav));
#line 195 "../plugins/CalDAV/CalDAVBackend.vala"
		webdav = _tmp4_;
#line 196 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp5_ = e_source_get_extension (source, E_SOURCE_EXTENSION_AUTHENTICATION);
#line 196 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, e_source_authentication_get_type (), ESourceAuthentication));
#line 196 "../plugins/CalDAV/CalDAVBackend.vala"
		auth = _tmp6_;
#line 197 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp7_ = e_source_get_extension (source, E_SOURCE_EXTENSION_OFFLINE);
#line 197 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, e_source_offline_get_type (), ESourceOffline));
#line 197 "../plugins/CalDAV/CalDAVBackend.vala"
		offline = _tmp8_;
#line 1316 "CalDAVBackend.c"
		{
			GeeIterator* _widget_it = NULL;
			GeeIterator* _tmp9_;
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp9_ = gee_iterable_iterator ((GeeIterable*) widgets);
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
			_widget_it = _tmp9_;
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
			while (TRUE) {
#line 1326 "CalDAVBackend.c"
				GeeIterator* _tmp10_;
				MayaPlacementWidget* widget = NULL;
				GeeIterator* _tmp11_;
				gpointer _tmp12_;
				MayaPlacementWidget* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				GQuark _tmp17_ = 0U;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp16_label0 = 0;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp16_label1 = 0;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp16_label2 = 0;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp16_label3 = 0;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				static GQuark _tmp16_label4 = 0;
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp10_ = _widget_it;
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				if (!gee_iterator_next (_tmp10_)) {
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
					break;
#line 1351 "CalDAVBackend.c"
				}
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp11_ = _widget_it;
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				widget = (MayaPlacementWidget*) _tmp12_;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp13_ = widget;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp14_ = _tmp13_->ref_name;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp15_ = _tmp14_;
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				_tmp17_ = (NULL == _tmp15_) ? 0 : g_quark_from_string (_tmp15_);
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
				if (_tmp17_ == ((0 != _tmp16_label0) ? _tmp16_label0 : (_tmp16_label0 = g_quark_from_static_string ("url_entry")))) {
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1371 "CalDAVBackend.c"
						default:
						{
							GUri* _tmp18_ = NULL;
							MayaPlacementWidget* _tmp19_;
							GtkWidget* _tmp20_;
							const gchar* _tmp21_;
							const gchar* _tmp22_;
							GUri* _tmp23_;
							ESourceWebdav* _tmp24_;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp19_ = widget;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp20_ = _tmp19_->widget;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp21_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_entry_get_type (), GtkEntry));
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp22_ = _tmp21_;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp23_ = g_uri_parse (_tmp22_, G_URI_FLAGS_NONE, &_inner_error0_);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp18_ = _tmp23_;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (widget);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (_widget_it);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (offline);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (auth);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (webdav);
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
								_g_object_unref0 (cal);
#line 1407 "CalDAVBackend.c"
								goto __catch0_g_error;
							}
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp24_ = webdav;
#line 202 "../plugins/CalDAV/CalDAVBackend.vala"
							g_object_set (_tmp24_, "uri", _tmp18_, NULL);
#line 206 "../plugins/CalDAV/CalDAVBackend.vala"
							_g_uri_unref0 (_tmp18_);
#line 206 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1418 "CalDAVBackend.c"
						}
					}
				} else if (_tmp17_ == ((0 != _tmp16_label1) ? _tmp16_label1 : (_tmp16_label1 = g_quark_from_static_string ("user_entry")))) {
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1424 "CalDAVBackend.c"
						default:
						{
							ESourceAuthentication* _tmp25_;
							MayaPlacementWidget* _tmp26_;
							GtkWidget* _tmp27_;
							const gchar* _tmp28_;
							const gchar* _tmp29_;
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp25_ = auth;
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp26_ = widget;
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp27_ = _tmp26_->widget;
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp28_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_entry_get_type (), GtkEntry));
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp29_ = _tmp28_;
#line 208 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_authentication_set_user (_tmp25_, _tmp29_);
#line 209 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1446 "CalDAVBackend.c"
						}
					}
				} else if (_tmp17_ == ((0 != _tmp16_label2) ? _tmp16_label2 : (_tmp16_label2 = g_quark_from_static_string ("email_entry")))) {
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1452 "CalDAVBackend.c"
						default:
						{
							ESourceWebdav* _tmp30_;
							MayaPlacementWidget* _tmp31_;
							GtkWidget* _tmp32_;
							const gchar* _tmp33_;
							const gchar* _tmp34_;
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp30_ = webdav;
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp31_ = widget;
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp32_ = _tmp31_->widget;
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp33_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_entry_get_type (), GtkEntry));
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp34_ = _tmp33_;
#line 211 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_webdav_set_email_address (_tmp30_, _tmp34_);
#line 212 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1474 "CalDAVBackend.c"
						}
					}
				} else if (_tmp17_ == ((0 != _tmp16_label3) ? _tmp16_label3 : (_tmp16_label3 = g_quark_from_static_string ("server_checkbutton")))) {
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1480 "CalDAVBackend.c"
						default:
						{
							ESourceWebdav* _tmp35_;
							MayaPlacementWidget* _tmp36_;
							GtkWidget* _tmp37_;
							gboolean _tmp38_;
							gboolean _tmp39_;
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp35_ = webdav;
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp36_ = widget;
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp37_ = _tmp36_->widget;
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp38_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_check_button_get_type (), GtkCheckButton));
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp39_ = _tmp38_;
#line 214 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_webdav_set_calendar_auto_schedule (_tmp35_, _tmp39_);
#line 215 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1502 "CalDAVBackend.c"
						}
					}
				} else if (_tmp17_ == ((0 != _tmp16_label4) ? _tmp16_label4 : (_tmp16_label4 = g_quark_from_static_string ("keep_copy")))) {
#line 199 "../plugins/CalDAV/CalDAVBackend.vala"
					switch (0) {
#line 1508 "CalDAVBackend.c"
						default:
						{
							ESourceOffline* _tmp40_;
							MayaPlacementWidget* _tmp41_;
							GtkWidget* _tmp42_;
							gboolean _tmp43_;
							gboolean _tmp44_;
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp40_ = offline;
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp41_ = widget;
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp42_ = _tmp41_->widget;
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp43_ = gtk_toggle_button_get_active ((GtkToggleButton*) G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_check_button_get_type (), GtkCheckButton));
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							_tmp44_ = _tmp43_;
#line 217 "../plugins/CalDAV/CalDAVBackend.vala"
							e_source_offline_set_stay_synchronized (_tmp40_, _tmp44_);
#line 218 "../plugins/CalDAV/CalDAVBackend.vala"
							break;
#line 1530 "CalDAVBackend.c"
						}
					}
				}
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (widget);
#line 1536 "CalDAVBackend.c"
			}
#line 198 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (_widget_it);
#line 1540 "CalDAVBackend.c"
		}
#line 222 "../plugins/CalDAV/CalDAVBackend.vala"
		e_source_write (source, NULL, NULL, NULL);
#line 223 "../plugins/CalDAV/CalDAVBackend.vala"
		if (set_default) {
#line 1546 "CalDAVBackend.c"
			ESourceRegistry* registry = NULL;
			ESourceRegistry* _tmp45_;
			ESourceRegistry* _tmp46_;
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp45_ = e_source_registry_new_sync (NULL, &_inner_error0_);
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
			registry = _tmp45_;
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (offline);
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (auth);
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (webdav);
#line 224 "../plugins/CalDAV/CalDAVBackend.vala"
				_g_object_unref0 (cal);
#line 1564 "CalDAVBackend.c"
				goto __catch0_g_error;
			}
#line 225 "../plugins/CalDAV/CalDAVBackend.vala"
			_tmp46_ = registry;
#line 225 "../plugins/CalDAV/CalDAVBackend.vala"
			g_object_set (_tmp46_, "default-calendar", source, NULL);
#line 223 "../plugins/CalDAV/CalDAVBackend.vala"
			_g_object_unref0 (registry);
#line 1573 "CalDAVBackend.c"
		}
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (offline);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (auth);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (webdav);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_object_unref0 (cal);
#line 1583 "CalDAVBackend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp47_;
		const gchar* _tmp48_;
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_error_ = _inner_error0_;
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_inner_error0_ = NULL;
#line 229 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp47_ = _error_;
#line 229 "../plugins/CalDAV/CalDAVBackend.vala"
		_tmp48_ = _tmp47_->message;
#line 229 "../plugins/CalDAV/CalDAVBackend.vala"
		g_critical ("CalDAVBackend.vala:229: %s", _tmp48_);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		_g_error_free0 (_error_);
#line 1603 "CalDAVBackend.c"
	}
	__finally0:
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		g_clear_error (&_inner_error0_);
#line 191 "../plugins/CalDAV/CalDAVBackend.vala"
		return;
#line 1614 "CalDAVBackend.c"
	}
}

static void
maya_cal_dav_backend_class_init (MayaCalDavBackendClass * klass,
                                 gpointer klass_data)
{
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	maya_cal_dav_backend_parent_class = g_type_class_peek_parent (klass);
#line 1624 "CalDAVBackend.c"
}

static void
maya_cal_dav_backend_maya_backend_interface_init (MayaBackendIface * iface,
                                                  gpointer iface_data)
{
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	maya_cal_dav_backend_maya_backend_parent_iface = g_type_interface_peek_parent (iface);
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	iface->get_name = (gchar* (*) (MayaBackend*)) maya_cal_dav_backend_real_get_name;
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	iface->get_uid = (gchar* (*) (MayaBackend*)) maya_cal_dav_backend_real_get_uid;
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	iface->get_new_calendar_widget = (GeeCollection* (*) (MayaBackend*, ESource*)) maya_cal_dav_backend_real_get_new_calendar_widget;
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	iface->add_new_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*)) maya_cal_dav_backend_real_add_new_calendar;
#line 32 "../plugins/CalDAV/CalDAVBackend.vala"
	iface->modify_calendar = (void (*) (MayaBackend*, const gchar*, const gchar*, gboolean, GeeCollection*, ESource*)) maya_cal_dav_backend_real_modify_calendar;
#line 1643 "CalDAVBackend.c"
}

static void
maya_cal_dav_backend_instance_init (MayaCalDavBackend * self,
                                    gpointer klass)
{
}

static GType
maya_cal_dav_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MayaCalDavBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_cal_dav_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaCalDavBackend), 0, (GInstanceInitFunc) maya_cal_dav_backend_instance_init, NULL };
	static const GInterfaceInfo maya_backend_info = { (GInterfaceInitFunc) maya_cal_dav_backend_maya_backend_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType maya_cal_dav_backend_type_id;
	maya_cal_dav_backend_type_id = g_type_register_static (G_TYPE_OBJECT, "MayaCalDavBackend", &g_define_type_info, 0);
	g_type_add_interface_static (maya_cal_dav_backend_type_id, MAYA_TYPE_BACKEND, &maya_backend_info);
	return maya_cal_dav_backend_type_id;
}

GType
maya_cal_dav_backend_get_type (void)
{
	static volatile gsize maya_cal_dav_backend_type_id__once = 0;
	if (g_once_init_enter (&maya_cal_dav_backend_type_id__once)) {
		GType maya_cal_dav_backend_type_id;
		maya_cal_dav_backend_type_id = maya_cal_dav_backend_get_type_once ();
		g_once_init_leave (&maya_cal_dav_backend_type_id__once, maya_cal_dav_backend_type_id);
	}
	return maya_cal_dav_backend_type_id__once;
}

